﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.8
@EndOfDesignText@
'LongText custom view, only Android
'Version 1.3
#DesignerProperty: Key: BackgroundColor, DisplayName: BackgroundColor, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Background color
#DesignerProperty: Key: TextColor, DisplayName: TextColor, FieldType: Color, DefaultValue: 0xFF000000, Description: Text color
#DesignerProperty: Key: TextSize, DisplayName: TextSize, FieldType: Int, DefaultValue: 14, Description: Text size
#DesignerProperty: Key: Editable, DisplayName: Editable, FieldType: Boolean, DefaultValue: True, Description: Enables or disables text editing
#DesignerProperty: Key: FastScrollEnabled, DisplayName: FastScrollEnabled, FieldType: Boolean, DefaultValue: True, Description: Enables or disables fast scrolling
#DesignerProperty: Key: FastScrollBackgroundColor, DisplayName: FastScrollBackgroundColor, FieldType: Color, DefaultValue: 0x20000000, Description: Fast scroll background color
#DesignerProperty: Key: FastScrollLimit, DisplayName: FastScrollLimit, FieldType: Int, DefaultValue: 10, Description: Fast scroll is enabled only if the text height is xx times the scrollview height.
#DesignerProperty: Key: FastScrollCursorColor, DisplayName: FastScrollCursorColor, FieldType: Color, DefaultValue: 0xFF0000FF, Description: Fast scroll cursor color
#DesignerProperty: Key: FastScrollCursorArrowColor, DisplayName: FastScrollCursorArrowColor, FieldType: Color, DefaultValue: 0xFFFFFF00, Description: Fast scroll cursor arrow color
#DesignerProperty: Key: FastScrollCursorShape, DisplayName: FastScrollCursorShape, FieldType: String, List: Two arrows|Oval, DefaultValue: Two arrows, Description: Fast scroll cursor shape

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object

	Private IME1 As IME
	Private StrUtil As StringUtils
	
	Private su As StringUtils
	Private scvText As ScrollView
	Public edtText As B4XView
	Private pnlFastScroll, pnlFastScrollCursor As B4XView
	
	Private mLeft, mTop, mWidth, mHeight As Int
	Private Padding As Int
	Private mBackgroundColor, mTextColor As Int
	Private mTextSize As Float
	Private mEditable As Boolean
	
	Private OriginalScrollViewHeight, SmallScrollViewHeight, CurrentMaxHeight As Int

	Private mFastScrollEnabled, FastScrollActive As Boolean
	Private mFastScrollCursorWidth, mFastScrollCursorHeight As Int
	Private mFastScrollBackgroundColor As Int
	Private mFastScrollCursorColor, mFastScrollCursorArrowColor As Int
	Private mFastScrollCursorShape As String
	Private mFastScrollHeight, mFastScrollLimit As Int
	Private FSY0, FSdY As Int
	Private FScScale As Double
	Private FScTimer As Timer
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, lbl As Label, Props As Map)
	mBase = Base
	Tag = mBase.Tag
	mBase.Tag = Me
	
	mLeft = mBase.Left
	mTop = mBase.Top
	mWidth = mBase.Width
	mHeight = mBase.Height
	OriginalScrollViewHeight = mHeight
	CurrentMaxHeight = OriginalScrollViewHeight
	
	mBackgroundColor = xui.PaintOrColorToColor(Props.GetDefault("BackgroundColor", 0xFFFFFFFF))
	mTextColor = xui.PaintOrColorToColor(Props.GetDefault("TextColor", 0xFF000000))
	mTextSize = Props.GetDefault("TextSize", 14)
	mEditable = Props.GetDefault("Editable", True)
	mFastScrollEnabled = Props.GetDefault("FastScrollEnabled", True)
	mFastScrollLimit = Props.GetDefault("FastScrollLimit", 10)
	mFastScrollBackgroundColor = xui.PaintOrColorToColor(Props.GetDefault("FastScrollBackgroundColor", 0x20000000))
	mFastScrollCursorColor = xui.PaintOrColorToColor(Props.GetDefault("FastScrollCursorColor", 0xFF0000FF))
	mFastScrollCursorArrowColor = xui.PaintOrColorToColor(Props.GetDefault("FastScrollCursorArrowColor", 0xFFFFFF00))
	mFastScrollCursorShape = Props.GetDefault("FastScrollCursorShape", "Two arrows")
	
	mBase.SetColorAndBorder(mBackgroundColor, 0, xui.Color_Transparent, 0)

	scvText.Initialize2(300, "scvText")
	mBase.AddView(scvText, 0, 0, mBase.Width, mBase.Height)
	
'	Private edt As EditText
	Private edt As AutoCompleteEditText
	edt.Initialize("edtText")
	edtText = edt
	edtText.Color = mBackgroundColor
	edtText.TextColor = mTextColor
	edtText.TextSize = mTextSize
	scvText.Panel.AddView(edtText, 2dip, 0, scvText.Width -4dip, scvText.Height)
	
	setEditable(mEditable)
	
	InitFastScroll
	DrawFastScrollCursor
	
	Private Padd(4) As Int
	Padd = edtText.As(EditText).Padding
	Padding = Padd(1) + Padd(2) + 5dip
	
	IME1.Initialize("IME1")
	IME1.AddHeightChangedEvent
	IME1.AddHandleActionEvent(edtText)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub

Public Sub setText(Text As String)
	Private Height As Int
	
	edtText.Text = Text
	Height = su.MeasureMultilineTextHeight(edtText, edtText.Text) + Padding + 5dip
	If Height < scvText.Height Then
		edtText.Height = Height
		mBase.Height = edtText.Height
		scvText.Height = edtText.Height
		scvText.Panel.Height = edtText.Height
		pnlFastScroll.Visible = False
	Else
		mBase.Height = OriginalScrollViewHeight
		scvText.Height = OriginalScrollViewHeight
		edtText.Height = Height
		scvText.Panel.Height = edtText.Height
		pnlFastScroll.Visible = mFastScrollEnabled And edtText.Height > mFastScrollLimit * OriginalScrollViewHeight
		FScScale = mFastScrollHeight / (edtText.Height - pnlFastScroll.Height)
	End If
End Sub
	
Public Sub getText As String
	Return edtText.Text
End Sub
	
Private Sub pnlFastScroll_Touch (Action As Int, X As Float, Y As Float)
	Select Action
		Case 0	'DOWN
			If Y >= pnlFastScrollCursor.Top And Y <= pnlFastScrollCursor.Top + pnlFastScrollCursor.Height Then
				FSY0 = pnlFastScrollCursor.Top
				FSdY = Y - FSY0
			End If
			FastScrollActive = True
		Case 2	'MOVE
			Private Top As Int
			Top = Max(Y - FSdY, 0)
			Top = Min(Top, pnlFastScroll.Height - pnlFastScrollCursor.Height)
			pnlFastScrollCursor.Top = Top
			scvText.ScrollPosition = Top / FScScale
			FastScrollActive = True
		Case 1	'UP
			FScTimer.Enabled = True
			FastScrollActive = False
	End Select
End Sub

Private Sub InitFastScroll
	mFastScrollCursorWidth = 25dip
	mFastScrollCursorHeight = 60dip
	pnlFastScroll = xui.CreatePanel("pnlFastScroll")
	pnlFastScroll.Color = mFastScrollBackgroundColor
'	pnlFastScroll.Visible = False
	mBase.AddView(pnlFastScroll,  mBase.Width - mFastScrollCursorWidth, mBase.Top, mFastScrollCursorWidth, mBase.Height)
	pnlFastScrollCursor = xui.CreatePanel("")
	pnlFastScrollCursor.Color = xui.Color_White
	pnlFastScroll.AddView(pnlFastScrollCursor,  0, 0, mFastScrollCursorWidth, mFastScrollCursorHeight)
	pnlFastScroll.Visible = False
	
	FScTimer.Initialize("FastScrollTimer", 1500)

	pnlFastScroll.Top = 0
	pnlFastScroll.Height = mBase.Height

	mFastScrollHeight = pnlFastScroll.Height - pnlFastScrollCursor.Height
	pnlFastScrollCursor.Top = 0

	DrawFastScrollCursor
End Sub

Private Sub FastScrollTimer_Tick
	If FastScrollActive = False Then
		FScTimer.Enabled = False
		pnlFastScroll.Visible = False
	End If
End Sub

'draws the fast scroll cursor
Private Sub DrawFastScrollCursor
	Private pthCursor, pthArrow As B4XPath
	Private cvsFSc As B4XCanvas
	Private x1, x2, x3, y1, y2, dd, rr As Int
	
	cvsFSc.Initialize(pnlFastScrollCursor)
	cvsFSc.ClearRect(cvsFSc.TargetRect)
	
	Select mFastScrollCursorShape
		Case "Two arrows"
			rr = 7dip
	
			pthCursor.InitializeRoundedRect(cvsFSc.TargetRect, rr)
			cvsFSc.DrawPath(pthCursor, mFastScrollCursorColor, True, 1dip)

			cvsFSc.DrawLine(5dip, mFastScrollCursorHeight / 2 - 5dip, mFastScrollCursorWidth - 5dip, mFastScrollCursorHeight / 2 - 5dip, mFastScrollCursorArrowColor, 1dip)
			cvsFSc.DrawLine(5dip, mFastScrollCursorHeight / 2, mFastScrollCursorWidth - 5dip, mFastScrollCursorHeight / 2, mFastScrollCursorArrowColor, 1dip)
			cvsFSc.DrawLine(5dip, mFastScrollCursorHeight / 2 + 5dip, mFastScrollCursorWidth - 5dip, mFastScrollCursorHeight / 2 + 5dip, mFastScrollCursorArrowColor, 1dip)
	
			dd = 7dip
			x2 = mFastScrollCursorWidth / 2
			x1 = x2 - dd
			x3 = x2 + dd
			y2 = dd
			y1 = y2 + dd
			pthArrow.Initialize(x1, y1)
			pthArrow.LineTo(x3, y1)
			pthArrow.LineTo(x2, y2)
			cvsFSc.DrawPath(pthArrow, mFastScrollCursorArrowColor, True, 1dip)
	
			x2 = mFastScrollCursorWidth / 2
			x1 = x2 - dd
			x3 = x2 + dd
			y2 = mFastScrollCursorHeight - dd
			y1 = y2 - dd
			pthArrow.Initialize(x1, y1)
			pthArrow.LineTo(x3, y1)
			pthArrow.LineTo(x2, y2)
			cvsFSc.DrawPath(pthArrow, mFastScrollCursorArrowColor, True, 1dip)
			cvsFSc.Invalidate
		Case "Oval"
			pthCursor.InitializeRoundedRect(cvsFSc.TargetRect, mFastScrollCursorWidth / 2)
			cvsFSc.DrawPath(pthCursor, mFastScrollCursorColor, True, 1dip)
	End Select

End Sub

Private Sub scvText_ScrollChanged(Position As Int)
	pnlFastScroll.Visible = mFastScrollEnabled And edtText.Height > mFastScrollLimit * OriginalScrollViewHeight
	pnlFastScrollCursor.Top = Position * FScScale
	FScTimer.Enabled = True
End Sub

Private Sub edtText_TextChanged (Old As String, New As String)
	CallSubDelayed3(Me, "CheckCursor", Old, New)
End Sub

Private Sub IME1_HeightChanged (NewHeight As Int, OldHeight As Int)
	Private xy() As Int
	
	If OldHeight > NewHeight And SmallScrollViewHeight = 0 Then
		SmallScrollViewHeight = NewHeight - mTop - 10dip	
	End If
	If mBase.Height < SmallScrollViewHeight Then Return
	
	If NewHeight > OldHeight Then
		CurrentMaxHeight = OriginalScrollViewHeight
		setHeight(CurrentMaxHeight)
		edtText.Top = 0
		xy = GetXYCursor(edtText, "BaseLine")
		scvText.ScrollPosition = xy(1) - OriginalScrollViewHeight / 2
		scvText.ScrollPosition = xy(1) - OriginalScrollViewHeight / 2
		scvText.ScrollPosition = xy(1) - OriginalScrollViewHeight / 2
		Sleep(0)
	Else 
'		If mBase.Height > SmallScrollViewHeight Then
			CurrentMaxHeight = SmallScrollViewHeight
		
			AdjustHeight(edtText.Text)
			xy = GetXYCursor(edtText, "BaseLine")
			If xy(1) - scvText.ScrollPosition > SmallScrollViewHeight Then
				edtText.Top = SmallScrollViewHeight - xy(1) - 5dip
				scvText.ScrollPosition = edtText.Top
			End If
	'	End If
	End If
End Sub

Private Sub CheckCursor(Old As String, New As String)
	Private hOld, hNew, xy(2) As Int
	
	If Old = "" Then Return
	
	hOld = StrUtil.MeasureMultilineTextHeight(edtText, Old) + Padding + 5dip
	hNew = StrUtil.MeasureMultilineTextHeight(edtText, New) + Padding + 5dip
	If hOld <> hNew Then
		AdjustHeight(New)
		xy = GetXYCursor(edtText, "BaseLine")
		If xy(1) > scvText.ScrollPosition + SmallScrollViewHeight Then
			edtText.Top = edtText.Top - (hOld - hNew)
		Else If xy(1) < scvText.ScrollPosition Then
			scvText.ScrollPosition = scvText.ScrollPosition + (hOld - hNew)
		End If
	End If
End Sub

Private Sub AdjustHeight(txt As String)
	Private Height As Int
	
	Height = StrUtil.MeasureMultilineTextHeight(edtText, txt) + Padding + 5dip
	
	If Height < CurrentMaxHeight Then
		setHeight(Height)
	Else
		setHeight(CurrentMaxHeight)
	End If
	edtText.Height = Height
	scvText.Panel.Height = Height
	FScScale = mFastScrollHeight / (edtText.Height - pnlFastScroll.Height)
End Sub

'gets the x and y coordinates, in pixels, of the cursor in an EditText view
'the Y coordinate is at the base line, on top or on bottom of the line
'returns an array of Ints
'X = xy(0) and Y = xy(1)
'the reference is the top left corner of the EditText
'YPosition can be "BaseLine", "TopOfLine", "BottomOfLine"
Private Sub GetXYCursor(edt As EditText, YPosition As String) As Int()
	Private joEditText, joLayout As JavaObject
	Private PaddingLeft, PaddingTop, ScrollY, Pos, Line, LineBaseline, LineTop, LineBottom As Int
	Private xy(2) As Int

	joEditText = edt
	PaddingLeft = joEditText.RunMethod("getPaddingLeft", Null)
	PaddingTop = joEditText.RunMethod("getPaddingTop", Null)
	ScrollY = joEditText.RunMethod("getScrollY", Null)
	'    pos = edt.SelectionStart
	Pos = joEditText.RunMethod("getSelectionStart", Null)
	joLayout = joEditText.RunMethod("getLayout", Null)
	Line = joLayout.RunMethod("getLineForOffset", Array As Object(Pos))    'line numbsr
	LineBaseline = joLayout.RunMethod("getLineBaseline", Array As Object(Line))
	LineTop = joLayout.RunMethod("getLineTop", Array As Object(Line))
	LineBottom = joLayout.RunMethod("getLineBottom", Array As Object(Line))
  
	xy(0) = joLayout.RunMethod("getPrimaryHorizontal", Array As Object(Pos)) + PaddingLeft ' X coordinate
	Select Case YPosition
		Case "BaseLine"
			xy(1) = LineBaseline + PaddingTop - ScrollY    'base line    Y coordinate
		Case "TopOfLine"
			xy(1) = LineTop + PaddingTop - ScrollY    'top of the line     Y coordinate
		Case "BottomOfLine"
			xy(1) = LineBottom + PaddingTop - ScrollY 'text bottom line
	End Select
	Return xy
End Sub

'Sets or gets the Left propety
Public Sub setLeft(Left As Int)
	mLeft = Left
	mBase.Left = mLeft
End Sub

Public Sub getLeft As Int
	Return mLeft
End Sub

'Sets or gets the Top propety
Public Sub setTop(Top As Int)
	mTop = Top
	mBase.Top = mTop
End Sub

Public Sub getTop As Int
	Return mTop
End Sub

'Sets or gets the Width propety
Public Sub setWidth(Width As Int)
	mWidth= Width
	mBase.Width = mWidth
	scvText.Width = mWidth
	scvText.Panel.Width = mWidth
	edtText.Width = mWidth
	pnlFastScroll.Left = scvText.Width - pnlFastScroll.Width
	setText(edtText.Text)
End Sub

Public Sub getWidth As Int
	Return mWidth
End Sub

'Sets or gets the Height propety
Public Sub setHeight(Height As Int)
	mHeight = Height
	OriginalScrollViewHeight = mHeight
	mBase.Height = mHeight
	scvText.Height = mHeight
	pnlFastScroll.Height = mBase.Height
	mFastScrollHeight = pnlFastScroll.Height - pnlFastScrollCursor.Height
	FScScale = mFastScrollHeight / (edtText.Height - pnlFastScroll.Height)
	setText(edtText.Text)
End Sub

Public Sub getHeight As Int
	Return mHeight
End Sub

'Sets or gets the ScrollPosition property
Public Sub setScrollPosition(ScrollPosition As Int)
	scvText.ScrollPosition = ScrollPosition
End Sub

Public Sub getScrollPosition As Int
	Return scvText.ScrollPosition
End Sub

'sets or gets the BackgroundColor property
Public Sub setBackgroundColor(BackgroundColor As Int)
	mBackgroundColor = BackgroundColor
	edtText.Color = mBackgroundColor
	mBase.Color = mBackgroundColor
End Sub

Public Sub getBackgroundColor As Int
	Return mBackgroundColor
End Sub

'sets or gets the TextColor property
Public Sub setTextColor(TextColor As Int)
	mTextColor = TextColor
	edtText.TextColor = TextColor
End Sub

Public Sub getTextColor As Int
	Return mTextColor
End Sub

'sets or gets the TextSize property
Public Sub setTextSize(TextSize As Float)
	mTextSize = TextSize
	edtText.TextSize = TextSize
	setText(edtText.Text)
End Sub

Public Sub getTextSize As Float
	Return mTextSize
End Sub

'sets or gets the Editable property
Public Sub setEditable(Editable As Boolean)
	mEditable = Editable
	
	Private mText As String
	mText = edtText.Text
	If mEditable = False Then
		edtText.As(EditText).InputType = edtText.As(EditText).INPUT_TYPE_NONE
	Else
		edtText.As(EditText).InputType = edtText.As(EditText).INPUT_TYPE_TEXT
	End If
	edtText.As(EditText).SingleLine = False
	edtText.Text = mText
End Sub

Public Sub getEditable As Boolean
	Return mEditable
End Sub

'sets or gets the FastScrollEnabled property
Public Sub setFastScrollEnabled(FastScrollEnabled As Boolean)
	mFastScrollEnabled = FastScrollEnabled
End Sub

Public Sub getFastScrollEnabled As Boolean
	Return mFastScrollEnabled
End Sub

'sets or gets the FastScrollLimit property
'Fast scroll is enabled only if the text height is FastScrollLimit times the scrollview height.
Public Sub setFastScrollLimit(FastScrollLimit As Int)
	mFastScrollLimit = FastScrollLimit
End Sub

Public Sub getFastScrollLimit As Int
	Return mFastScrollLimit
End Sub

'sets or gets the FastScrollBackgroundColor property
Public Sub setFastScrollBackgroundColor(FastScrollBackgroundColor As Int)
	mFastScrollBackgroundColor = FastScrollBackgroundColor
	pnlFastScroll.Color = mFastScrollBackgroundColor
End Sub

Public Sub getFastScrollBackgroundColor As Int
	Return mFastScrollBackgroundColor
End Sub

'sets or gets the FastScrollCursorColor property
Public Sub setFastScrollCursorColor(FastScrollCursorColor As Int)
	mFastScrollCursorColor = FastScrollCursorColor
	DrawFastScrollCursor
End Sub

Public Sub getFastScrollCursorColor As Int
	Return mFastScrollCursorColor
End Sub

'sets or gets the FastScrollCursorArrowColor property
Public Sub setFastScrollCursorArrowColor(FastScrollCursorArrowColor As Int)
	mFastScrollCursorArrowColor = FastScrollCursorArrowColor
	DrawFastScrollCursor
End Sub

Public Sub getFastScrollCursorArrowColor As Int
	Return mFastScrollCursorArrowColor
End Sub

'sets or gets the FastScrollCursorShape property
Public Sub setFastScrollCursorShape(FastScrollCursorShape As String)
	mFastScrollCursorShape = FastScrollCursorShape
	DrawFastScrollCursor
End Sub

Public Sub getFastScrollCursorShape As String
	Return mFastScrollCursorShape
End Sub


